﻿from scriptforge import CreateScriptService
import csv
import datetime

doc = CreateScriptService("Calc")


def Sprzedaz(args=None):
    licznik = 6
    f = open('D:\\Documents\\JPK\\s23_12_2023.csv', 'r', encoding='utf-8')
    doc.Activate("sprzedaz")
    # coords = ["C", str(6)]
    # doc.SetValue(''.join(coords), "SSSSS")

    with f:
        czytacz = csv.reader(f, delimiter=',')
        for row in czytacz:
            if row[0] == 's23':
                # writer.writerow({'LpSprzedazy' : str(licznik), 'NrKontrahenta' : row[5], 'NazwaKontrahenta' : row[4], 'AdresKontrahenta' : adres, 'DowodSprzedazy' : row[7], 'DataWystawienia' : row[1], 'K_19': row[8].replace(",","."), 'K_20' : row[9].replace(",",".")})
                # NIP
                coords = ["C", str(licznik)]
                doc.SetValue(''.join(coords), row[5])
                coords.clear()
                # NazwaKontrahenta
                coords = ["D", str(licznik)]
                doc.SetValue(''.join(coords), row[4])
                coords.clear()
                # DowodSprzedazy
                coords = ["E", str(licznik)]
                doc.SetValue(''.join(coords), row[7])
                coords.clear()
                # DataWystawienia
                coords = ["F", str(licznik)]
                doc.SetValue(''.join(coords), row[1])
                coords.clear()
                # VAT 23 netto, czyli K_19
                coords = ["W", str(licznik)]
                doc.SetValue(''.join(coords), float(row[8].replace(",",".")))
                coords.clear()
                # VAT 23 VAT, czyli K_20
                coords = ["X", str(licznik)]
                doc.SetValue(''.join(coords), float(row[9].replace(",",".")))
                coords.clear()
            elif row[0] == 'sn':
                if row[5] == 'BRAK':
                    # writer.writerow({'LpSprzedazy' : str(licznik), 'NrKontrahenta' : row[5], 'NazwaKontrahenta' : row[4], 'AdresKontrahenta' : adres, 'DowodSprzedazy' : row[7], 'DataWystawienia' : row[1], 'K_11': row[8].replace(",",".")})
                    # NIP
                    coords = ["C", str(licznik)]
                    doc.SetValue(''.join(coords), row[5])
                    coords.clear()
                    # NazwaKontrahenta
                    coords = ["D", str(licznik)]
                    doc.SetValue(''.join(coords), row[4])
                    coords.clear()
                    # DowodSprzedazy
                    coords = ["E", str(licznik)]
                    doc.SetValue(''.join(coords), row[7])
                    coords.clear()
                    # DataWystawienia
                    coords = ["F", str(licznik)]
                    doc.SetValue(''.join(coords), row[1])
                    coords.clear()
                    # netto usługi zagraniczne, czyli K_11
                    coords = ["O", str(licznik)]
                    doc.SetValue(''.join(coords), float(row[8].replace(",",".")))
                    coords.clear()
                    #
                    # coords = ["X", str(licznik)]
                    # doc.SetValue(''.join(coords), row[9])
                    # coords.clear()
                else:
                    # writer.writerow({'LpSprzedazy' : str(licznik), 'NrKontrahenta' : row[5], 'NazwaKontrahenta' : row[4], 'AdresKontrahenta' : adres, 'DowodSprzedazy' : row[7], 'DataWystawienia' : row[1], 'K_11': row[8].replace(",","."), 'K_12' : row[8].replace(",",".")})
                    nip = row[5]
                    if (nip[0:2].isalpha() and nip[2:].isnumeric()):
                        ck = ["B", str(licznik)]
                        coords = ["C", str(licznik)]
                        #wstawianie kodu kraju
                        doc.SetValue(''.join(ck), nip[0:2])
                        ck.clear()
                        #stawianie reszty nipu
                        doc.SetValue(''.join(coords), nip[2:])
                        coords.clear()
                    else:
                        coords = ["C", str(licznik)]
                        doc.SetValue(''.join(coords), row[5])
                        coords.clear()


                    # NazwaKontrahenta
                    coords = ["D", str(licznik)]
                    doc.SetValue(''.join(coords), row[4])
                    coords.clear()
                    # DowodSprzedazy
                    coords = ["E", str(licznik)]
                    doc.SetValue(''.join(coords), row[7])
                    coords.clear()
                    # DataWystawienia
                    coords = ["F", str(licznik)]
                    doc.SetValue(''.join(coords), row[1])
                    coords.clear()
                    # netto usługi zagraniczne, czyli K_11
                    coords = ["O", str(licznik)]
                    doc.SetValue(''.join(coords), float(row[8].replace(",",".")))
                    coords.clear()
                    # netto usługi art.100, czyli K_12
                    coords = ["P", str(licznik)]
                    doc.SetValue(''.join(coords), float(row[8].replace(",",".")))
                    coords.clear()
            else:
                # writer.writerow({'LpSprzedazy' : str(licznik), 'NrKontrahenta' : row[5], 'NazwaKontrahenta' : row[4], 'AdresKontrahenta' : adres, 'DowodSprzedazy' : row[7], 'DataWystawienia' : row[1], 'K_29': row[8].replace(",","."), 'K_30' : row[9].replace(",",".")})
                # NIP
                nip = row[5]
                if (nip[0:2].isalpha() and nip[2:].isnumeric()):
                    ck = ["B", str(licznik)]
                    coords = ["C", str(licznik)]
                    #wstawianie kodu kraju
                    doc.SetValue(''.join(ck), nip[0:2])
                    ck.clear()
                    #stawianie reszty nipu
                    doc.SetValue(''.join(coords), nip[2:])
                    coords.clear()
                else:
                    coords = ["C", str(licznik)]
                    doc.SetValue(''.join(coords), row[5])
                    coords.clear()


                # NazwaKontrahenta
                coords = ["D", str(licznik)]
                doc.SetValue(''.join(coords), row[4])
                coords.clear()
                # DowodSprzedazy
                coords = ["E", str(licznik)]
                doc.SetValue(''.join(coords), row[7])
                coords.clear()
                # DataWystawienia
                coords = ["F", str(licznik)]
                doc.SetValue(''.join(coords), row[1])
                coords.clear()
                # VAT 23 netto od zakupu usług zagranicznych, czyli K_29
                coords = ["AG", str(licznik)]
                doc.SetValue(''.join(coords), float(row[8].replace(",",".")))
                coords.clear()
                # VAT 23 VAT od zakupu usług zagranicznych, czyli K_30
                coords = ["AH", str(licznik)]
                doc.SetValue(''.join(coords), float(row[9].replace(",",".")))
                coords.clear()
            licznik += 1
    f.close()



def Zakupy(args=None):
    zlicznik = 6
    z = open('D:\\Documents\\JPK\\ZPZO_12_2023.csv', 'r', encoding='utf-8')
    doc.Activate("zakupy")

    with z:
        zczytacz = csv.reader(z, delimiter=',')

        for zrow in zczytacz:
            # writer.writerow({'LpZakupu' : str(zlicznik), 'NrDostawcy' : zrow[5], 'NazwaDostawcy' : nazwa, 'AdresDostawcy' : adres, 'DowodZakupu' : zrow[7], 'DataZakupu' : zrow[1], 'DataWplywu' : zrow[2], 'K_45' : zrow[8].replace(",","."), 'K_46' : zrow[9].replace(",",".")})
            # NIP
            nip = zrow[5]
            if (nip[0:2].isalpha() and nip[2:].isnumeric()):
                ck = ["B", str(zlicznik)]
                coords = ["C", str(zlicznik)]
                #wstawianie kodu kraju
                doc.SetValue(''.join(ck), nip[0:2])
                ck.clear()
                #stawianie reszty nipu
                doc.SetValue(''.join(coords), nip[2:])
                coords.clear()
            else:
                coords = ["C", str(zlicznik)]
                doc.SetValue(''.join(coords), zrow[5])
                coords.clear()


            # NazwaDostawcy
            coords = ["D", str(zlicznik)]
            doc.SetValue(''.join(coords), zrow[4])
            coords.clear()
            # DowodZakupu
            coords = ["E", str(zlicznik)]
            doc.SetValue(''.join(coords), zrow[7])
            coords.clear()
            # DataWystawienia
            coords = ["F", str(zlicznik)]
            doc.SetValue(''.join(coords), zrow[1])
            coords.clear()
            # VAT 23 netto, czyli K_19
            coords = ["L", str(zlicznik)]
            doc.SetValue(''.join(coords), float(zrow[8].replace(",",".")))
            coords.clear()
            # VAT 23 VAT, czyli K_20
            coords = ["M", str(zlicznik)]
            doc.SetValue(''.join(coords), float(zrow[9].replace(",",".")))
            coords.clear()
            zlicznik += 1
    z.close()


def Vatue(args=None):
    # Taka ciekawoska, datą wyjściową w Calcu, jest 30-12-1899
    calc_base_date = datetime.datetime(1899, 12, 30)
    # a potrzebujemy tej zmiennej, żeby przekształcić datę ur.
    dataur = doc.GetValue("start.B27")
    # ściągniętą z arkusza 'start'
    target_date = calc_base_date + datetime.timedelta(days=dataur)
    # obliczamy ją i przektształcamy na łańcuch
    data_string = target_date.strftime("%Y-%m-%d")
    # następne 3 wiersze po komentarzu to obliczenie numeru poprzedniego miesiąca
    # taką miałem pierwotną koncepcję, ale potem pomyślałem, że będę ściągał
    # wszystko z arkusza start, dzięki czemu nie musisz edytować XML
    # no prawie, bo KOD URZĘDU musisz jednak wpisać ręcznie
    current_date = datetime.datetime.now()
    previous_month_date = current_date - datetime.timedelta(days=current_date.day)
    pmns = previous_month_date.strftime("%#m")
    # pobieramy rok i miesiąc z arkusza start
    rstart = str(doc.GetValue("start.B11"))
    mstart = str(doc.GetValue("start.B12"))
    # przełączamy się na sprzedaż, bo skrypt działa na tym arkuszu
    # który akurat jest wyświetlany
    doc.Activate("sprzedaz")
    # otwieramy plik, w którym zapiszemy VAT UE
    # po przebiegu skryptu zmień jego nazwę, bo następne uruchomienie dopisze się na końcu pliku
    # dostosuj też ścieżkę i nazwę pliku do swoich wymagań
    euvat = open("D:\\Documents\JPK\\VATUE_DRAFT.xml", mode="a", encoding="utf-8")
    # Zapisujemy do pliku strukturę początkową, pamiętaj - zmień kod urzędu na swoj!
    # teksty w nawiasach klamrowych zostaną zastąpione przez metodę format
    # co ciekawe NIP jest zapisany jako float, więc trzeba najpierw go zmienić na int
    # a potem na ciąg tekstowy
    euvat.write('''<?xml version="1.0" encoding="UTF-8"?>
    <Deklaracja xmlns="http://crd.gov.pl/wzor/2021/01/12/10293/">
        <Naglowek>
            <KodFormularza kodSystemowy="VAT-UE (5)" wersjaSchemy="2-0E">VAT-UE</KodFormularza>
            <WariantFormularza>5</WariantFormularza>
            <Rok>{rok}</Rok>
            <Miesiac>{miesiac}</Miesiac>
            <CelZlozenia>1</CelZlozenia>
            <KodUrzedu>0000</KodUrzedu>
	</Naglowek>
	<Podmiot1 rola="Podatnik">
		<etd:OsobaFizyczna xmlns:etd="http://crd.gov.pl/xml/schematy/dziedzinowe/mf/2020/03/11/eD/DefinicjeTypy/">
			<etd:NIP>{nip}</etd:NIP>
			<etd:ImiePierwsze>{imie}</etd:ImiePierwsze>
			<etd:Nazwisko>{nazwisko}</etd:Nazwisko>
			<etd:DataUrodzenia>{data_ur}</etd:DataUrodzenia>
		</etd:OsobaFizyczna>
	</Podmiot1>
	<PozycjeSzczegolowe>
	'''.format(rok = rstart, miesiac = mstart, imie = doc.GetValue("start.B25"), nazwisko = doc.GetValue("start.B26"), data_ur = data_string, nip = str(int(doc.GetValue("start.B20")))))

    # bas do debugowania i wyświetlenia komunikatu
    bas = CreateScriptService("Basic")
    # ustalenie ostatniego wiersza
    ostatni = doc.LastRow("sprzedaz")
    ostatni = ostatni+1
    zakres = list(range(6, ostatni))
    for ws in zakres:
        # ~. to takie odniesienie do bieżacego arkusza
        # wspołrzędne to lista, ktorą scalamy
        coords = ["~.", "B", str(ws)]
        # pobieramy wartość z kolumny kodu kraju
        kraj  = doc.GetValue(''.join(coords))
        coords.clear()
        # sprawdzamy czy komorka zawierała jakiś kod kraju
        # a jak zawiera, to działamy odpowiednio
        if len(kraj) > 0:
            # tworzymy pustą listę, wypełniamy ją i zrzucimy do pliku
            # na końcu iteracji
            wpis = []
            wpis.append(kraj)
            coords = ["~.", "C", str(ws)]
            # pobieramy NIP, co ciekawe tu jest ciągiem tekstowym
            nip = doc.GetValue(''.join(coords))
            # muszę pominąć jednego kontrahenta, od ktorego kupuję usługę zagr.
            # bo tego się nie raportuje
            # jeśli masz więcej do pominięcia, użyj elif
            if nip == "0000000000":
                continue
            coords.clear()
            # dodajemy NIP do listy
            wpis.append(nip)
            coords = ["~.", "O", str(ws)]
            # pobieramy kwotę
            kwota = doc.GetValue(''.join(coords))
            # tk = type(kwota)
            # ślady pod debugowaniu
            # bas.MsgBox(kwota)
            # ponieważ podczas pracy nad skryptem
            # kwoty były roznie odczytywane, dlatego
            # sprawdzamy tym zmiennej i odpowiednio działamy
            # i zaokrąglamy
            if isinstance(kwota, str):
                numer = float(kwota.replace(",","."))
                zaokr = round(numer)
                tekstowo = str(zaokr)
                wpis.append(tekstowo)
                coords.clear()
            else:
                zaokr = round(kwota)
                tekstowo = str(zaokr)
                wpis.append(tekstowo)

            # tekstwpisu = ' '.join(wpis)
            # bas.MsgBox(tekstwpisu)
            # teraz mamy wszystko, co trzebam, by wypełnić Grupę 3
            # wiec zrzucamy ją do pliku
            euvat.write('''<Grupa3>
			<P_Ua>{kk}</P_Ua>
			<P_Ub>{tin}</P_Ub>
			<P_Uc>{okragla}</P_Uc>
            </Grupa3>
            '''.format(kk = wpis[0], tin = wpis[1], okragla = wpis[2]))
            # zerujemy listę
            wpis = []
        else:
            # jak nie było kodu kraju, przeskakujemy pętlę
            # do następnego wiersza
            continue

    # Dopisujemy zakończenie pliku
    euvat.write('''</PozycjeSzczegolowe>
	<Pouczenie>1</Pouczenie>
    </Deklaracja>''')
    # i zamykamy go
    euvat.close()
    bas.MsgBox("Gotowe! Otwórz plik w edytorze tekstowym i sprawdź, czy wszystko OK.")





g_exportedScripts = (Sprzedaz, Zakupy, Vatue)
